//------------------------------------------------------------------------------
// <auto-generated />
//
// This file was automatically generated by SWIG (http://www.swig.org).
// Version 3.0.12
//
// Do not make changes to this file unless you know what you are doing--modify
// the SWIG interface file instead.
//------------------------------------------------------------------------------

namespace OpenMMNET {

public class GBSAOBCForce : Force {
  private global::System.Runtime.InteropServices.HandleRef swigCPtr;

  internal GBSAOBCForce(global::System.IntPtr cPtr, bool cMemoryOwn) : base(OpenMMSwigPINVOKE.GBSAOBCForce_SWIGUpcast(cPtr), cMemoryOwn) {
    swigCPtr = new global::System.Runtime.InteropServices.HandleRef(this, cPtr);
  }

  internal static global::System.Runtime.InteropServices.HandleRef getCPtr(GBSAOBCForce obj) {
    return (obj == null) ? new global::System.Runtime.InteropServices.HandleRef(null, global::System.IntPtr.Zero) : obj.swigCPtr;
  }

  ~GBSAOBCForce() {
    Dispose();
  }

  public override void Dispose() {
    lock(this) {
      if (swigCPtr.Handle != global::System.IntPtr.Zero) {
        if (swigCMemOwn) {
          swigCMemOwn = false;
          OpenMMSwigPINVOKE.delete_GBSAOBCForce(swigCPtr);
        }
        swigCPtr = new global::System.Runtime.InteropServices.HandleRef(null, global::System.IntPtr.Zero);
      }
      global::System.GC.SuppressFinalize(this);
      base.Dispose();
    }
  }

  public GBSAOBCForce() : this(OpenMMSwigPINVOKE.new_GBSAOBCForce(), true) {
  }

  public int getNumParticles() {
    int ret = OpenMMSwigPINVOKE.GBSAOBCForce_getNumParticles(swigCPtr);
    return ret;
  }

  public int addParticle(double charge, double radius, double scalingFactor) {
    int ret = OpenMMSwigPINVOKE.GBSAOBCForce_addParticle(swigCPtr, charge, radius, scalingFactor);
    return ret;
  }

  public void getParticleParameters(int index, SWIGTYPE_p_double charge, SWIGTYPE_p_double radius, SWIGTYPE_p_double scalingFactor) {
    OpenMMSwigPINVOKE.GBSAOBCForce_getParticleParameters(swigCPtr, index, SWIGTYPE_p_double.getCPtr(charge), SWIGTYPE_p_double.getCPtr(radius), SWIGTYPE_p_double.getCPtr(scalingFactor));
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

  public void setParticleParameters(int index, double charge, double radius, double scalingFactor) {
    OpenMMSwigPINVOKE.GBSAOBCForce_setParticleParameters(swigCPtr, index, charge, radius, scalingFactor);
  }

  public double getSolventDielectric() {
    double ret = OpenMMSwigPINVOKE.GBSAOBCForce_getSolventDielectric(swigCPtr);
    return ret;
  }

  public void setSolventDielectric(double dielectric) {
    OpenMMSwigPINVOKE.GBSAOBCForce_setSolventDielectric(swigCPtr, dielectric);
  }

  public double getSoluteDielectric() {
    double ret = OpenMMSwigPINVOKE.GBSAOBCForce_getSoluteDielectric(swigCPtr);
    return ret;
  }

  public void setSoluteDielectric(double dielectric) {
    OpenMMSwigPINVOKE.GBSAOBCForce_setSoluteDielectric(swigCPtr, dielectric);
  }

  public double getSurfaceAreaEnergy() {
    double ret = OpenMMSwigPINVOKE.GBSAOBCForce_getSurfaceAreaEnergy(swigCPtr);
    return ret;
  }

  public void setSurfaceAreaEnergy(double energy) {
    OpenMMSwigPINVOKE.GBSAOBCForce_setSurfaceAreaEnergy(swigCPtr, energy);
  }

  public GBSAOBCForce.NonbondedMethod getNonbondedMethod() {
    GBSAOBCForce.NonbondedMethod ret = (GBSAOBCForce.NonbondedMethod)OpenMMSwigPINVOKE.GBSAOBCForce_getNonbondedMethod(swigCPtr);
    return ret;
  }

  public void setNonbondedMethod(GBSAOBCForce.NonbondedMethod method) {
    OpenMMSwigPINVOKE.GBSAOBCForce_setNonbondedMethod(swigCPtr, (int)method);
  }

  public double getCutoffDistance() {
    double ret = OpenMMSwigPINVOKE.GBSAOBCForce_getCutoffDistance(swigCPtr);
    return ret;
  }

  public void setCutoffDistance(double distance) {
    OpenMMSwigPINVOKE.GBSAOBCForce_setCutoffDistance(swigCPtr, distance);
  }

  public void updateParametersInContext(Context context) {
    OpenMMSwigPINVOKE.GBSAOBCForce_updateParametersInContext(swigCPtr, Context.getCPtr(context));
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

  public override bool usesPeriodicBoundaryConditions() {
    bool ret = OpenMMSwigPINVOKE.GBSAOBCForce_usesPeriodicBoundaryConditions(swigCPtr);
    return ret;
  }

  public enum NonbondedMethod {
    NoCutoff = 0,
    CutoffNonPeriodic = 1,
    CutoffPeriodic = 2
  }

}

}
